//
// C++ Implementation: pe_options
//
// Description: 
//
//
// Author: root <root@andLinux>, (C) 2009
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include "ZSettingDlg.h"
#include <QDaemonApp.h>
#include <ZSoftKey.h>
#include <ZAppInfoArea.h>
//#include <ZFormContainer.h>
#include <ZConfig.h>
//#include <ZSeparator.h>
#include "ZDefs.h"
#include "lng.h"
//#include <ZLabel.h>
//#include <ZComboBox.h>

extern ZTaskMan *zTaskMan;
extern QDaemonApp *app;
extern ZLng* lng;

bool chang;


ZAppSetting::ZAppSetting()
{
	zTaskMan->toLog("ZSettingDlg: Start");
	
	setMainWidgetTitle(lng->LNG_DLG_SETTING);
	
	//ZFormContainer *form = new ZFormContainer(this, 0, ZSkinService::clsZFormContainer);
	form = new kListBox(300);
	form->showPid=false;

	chk[0].load(zTaskMan->ProgDir+"/img/unchk.png");
	chk[1].load(zTaskMan->ProgDir+"/img/chk.png");

	//zTaskMan->toLog("ZSettingDlg: Create CheckBox and Load settings");
	
	ZConfig cfg(zTaskMan->ProgDir+appConf);
	
	addChkBox(lng->LNG_PROCFILTER, !cfg.readBoolEntry("Task", "FiltrProc", false));
	addChkBox(lng->LNG_TASKNOWIN, cfg.readBoolEntry("Task", "ShowAppNoWindow", false));
	addChkBox(lng->LNG_JAVAICON, cfg.readBoolEntry("Task", "ShowJavaIcon", false));
	addChkBox(lng->LNG_PID, cfg.readBoolEntry("Task", "ShowPid", false));
	
	addChkBox(lng->LNG_SENDREASEPHONE, cfg.readBoolEntry("General", "SendReaisePhone", false));
	addChkBox(lng->LNG_SENDTOIDLE, cfg.readBoolEntry("General", "SendGoToIDLE", false));
	addChkBox(lng->LNG_UPDATEONRAISE, cfg.readBoolEntry("General", "UpdateProcListOnRaise", false));
	
	lang=cfg.readEntry("General", "Lng","Russian.lng");
	addChkBox(lng->LNG_LANG+": "+lang, "/img/lang.png");
	
	addChkBox(lng->LNG_OK, "/img/save.png");
	addChkBox(lng->LNG_CANCEL, "/img/cancel.png");
	/*zcbSendReasePhone = new ZMyCheckBox(lng->LNG_SENDREASEPHONE,this,"",cfg.readBoolEntry(QString("General"), QString("SendReaisePhone"), false));
	zcbSendGoToIDLE = new ZMyCheckBox(lng->LNG_SENDTOIDLE,this,"",cfg.readBoolEntry(QString("General"), QString("SendGoToIDLE"), false));
	zcbUpdateOnRaise = new ZMyCheckBox(lng->LNG_UPDATEONRAISE,this,"",cfg.readBoolEntry(QString("General"), QString("UpdateProcListOnRaise"), false));
	
	zcbFiltrProc = new ZMyCheckBox(lng->LNG_PROCFILTER,this,"",!cfg.readBoolEntry(QString("Task"), QString("FiltrProc"), false));
	zcbTaskNoWin = new ZMyCheckBox(lng->LNG_TASKNOWIN,this,"",cfg.readBoolEntry(QString("Task"), QString("ShowAppNoWindow"), false));
	zcbJavaIcon = new ZMyCheckBox(lng->LNG_JAVAICON,this,"",cfg.readBoolEntry(QString("Task"), QString("ShowJavaIcon"), false));
	//zcbNativIcon = new ZMyCheckBox(lng->LNG_NATIVICON,this,"",cfg.readBoolEntry(QString("Task"), QString("ShowNativIcon"), false));
	//zcbRunAppIcon = new ZMyCheckBox(lng->LNG_RUNICON,this,"",cfg.readBoolEntry(QString("Task"), QString("ShowIconOnRunApp"), false));
	
	zlLang = new ZLabel(lng->LNG_LANG,this);
	
	zcbLanguage = new ZComboBox(this, "LanguageBox", true);
	lng->getLngList(zcbLanguage, cfg.readEntry(QString("General"), QString("Lng"),"Russian.lng"));*/
	
	cfg.flush();
	
	chang = false;
	
	/*zTaskMan->toLog("ZSettingDlg: init interfase");

	form->addChild(zcbFiltrProc,true);
	form->addChild(zcbTaskNoWin,true);
	ZSeparator *sep = new ZSeparator();
	form->addChild(sep,true);
	form->addChild(zcbJavaIcon,true);
	//form->addChild(zcbNativIcon,true);
	//form->addChild(zcbRunAppIcon,true);
	sep = new ZSeparator();
	form->addChild(sep,true);
	form->addChild(zcbSendReasePhone,true);
	form->addChild(zcbSendGoToIDLE,true);
	form->addChild(zcbUpdateOnRaise,true);
	sep = new ZSeparator();
	form->addChild(sep,true);
	form->addChild(zlLang,true);
	form->addChild(zcbLanguage,true);

	ZSoftKey *softKey = this->getSoftKey(true);
	setMainWidgetTitle(lng->LNG_DLG_SETTING);
	softKey->setText ( ZSoftKey::LEFT, lng->LNG_OK, ( ZSoftKey::TEXT_PRIORITY ) 0 );
	softKey->setText ( ZSoftKey::RIGHT, lng->LNG_CANCEL, ( ZSoftKey::TEXT_PRIORITY ) 0 );
	softKey->setClickedSlot ( ZSoftKey::RIGHT, this, SLOT ( reject() ) );
	softKey->setClickedSlot ( ZSoftKey::LEFT, this, SLOT ( accept() ) );
	
	connect(zcbLanguage,SIGNAL(textChanged( const QString )),this,SLOT(zCombBoxtextChanged()));	
	*/
	/*kListBoxItem listitem;
	
	listitem.Icon=chk[0];
	listitem.Name="test";
	listitem.Pid=1;	
	form->addItem(listitem);*/
	
	this->setContentWidget(form);
	connect(form, SIGNAL (selected(int)),		this, SLOT (lbProcSel(int)) );
	form->setFocus();
	zTaskMan->toLog("ZSettingDlg: end");
}

void ZAppSetting::addChkBox(QString name, int bul)
{
	kListBoxItem listitem;
	listitem.Icon=chk[bul];
	listitem.Name=name;
	listitem.Pid=bul+1;	
	form->addItem(listitem);
}

void ZAppSetting::addChkBox(QString name, QString icon)
{
	kListBoxItem listitem;
	listitem.Icon.load(zTaskMan->ProgDir+icon);
	listitem.Name=name;
	listitem.Pid=0;	
	form->addItem(listitem);
}

void ZAppSetting::lbProcSel(int i)
{
	kListBoxItem listitem=form->item(i);
	int bul=listitem.Pid-1;
	bul=!bul;
	switch (i)
	{
		case 7:			
		break;
		
		case 8:
			accept();
		break;
		
		case 9:
			reject();
		break;
		
		default:
			form->changeItem(i, NULL, chk[bul], bul+1);
			chang = true;
		break;
	}
}

ZAppSetting::~ZAppSetting()
{
	delete form;
	/*delete zcbFiltrProc;
	delete zcbJavaIcon;
	//delete zcbNativIcon;
	//delete zcbRunAppIcon;
	delete zcbSendReasePhone;
	delete zcbSendGoToIDLE;
	delete zcbUpdateOnRaise;*/
}

void ZAppSetting::accept()
{
	zTaskMan->toLog("ZSettingDlg: write setting");
	ZConfig cfg(zTaskMan->ProgDir+appConf);
	cfg.writeEntry("Task", "FiltrProc", !(form->getPid(0)-1));
	cfg.writeEntry("Task", "ShowAppNoWindow", form->getPid(1)-1);
	cfg.writeEntry("Task", "ShowJavaIcon", form->getPid(2)-1);
	cfg.writeEntry("Task", "ShowPid", form->getPid(3)-1);
	cfg.writeEntry("General", "SendReaisePhone", form->getPid(4)-1);  
	cfg.writeEntry("General", "SendGoToIDLE", form->getPid(5)-1);
	cfg.writeEntry("General", "UpdateProcListOnRaise", form->getPid(6)-1);
	cfg.writeEntry("General", "Lng", lang);
	
	/*cfg.writeEntry("Task", "FiltrProc", !zcbFiltrProc->GetChecked() );
	cfg.writeEntry("Task", "ShowAppNoWindow", zcbTaskNoWin->GetChecked() );
	cfg.writeEntry("Task", "ShowJavaIcon", zcbJavaIcon->GetChecked() );
	//cfg.writeEntry("Task", "ShowNativIcon", zcbNativIcon->GetChecked() );
	//cfg.writeEntry("Task", "ShowIconOnRunApp", zcbRunAppIcon->GetChecked() );
	cfg.writeEntry("General", "SendReaisePhone", zcbSendReasePhone->GetChecked() );  
	cfg.writeEntry("General", "SendGoToIDLE", zcbSendGoToIDLE->GetChecked() );
	cfg.writeEntry("General", "UpdateProcListOnRaise", zcbUpdateOnRaise->GetChecked() );
	cfg.writeEntry("General", "Lng", lng->getLngFileName( zcbLanguage->currentText() ) );*/
	cfg.flush();
	
	change=chang;
	if (chang)
	{
		zTaskMan->toLog("ZSettingDlg: end write setting");
		
		zTaskMan->cfg_FiltrProc = !(form->getPid(0)-1);
		zTaskMan->cfg_ShowAppNoWindow = form->getPid(1)-1;
		zTaskMan->cfg_ShowJavaIcon = form->getPid(2)-1;
		zTaskMan->cfg_ShowPid = form->getPid(3)-1;
		
		zTaskMan->cfg_SendReaisePhone = form->getPid(4)-1;
		zTaskMan->cfg_SendGoToIDLE = form->getPid(5)-1;
		zTaskMan->cfg_UpdateOnRaise = form->getPid(6)-1;
		
		//zTaskMan->cfg_ShowNativIcon = zcbNativIcon->GetChecked();
		//zTaskMan->cfg_ShowIconOnRunApp = zcbRunAppIcon->GetChecked();
		
		zTaskMan->toLog("ZSettingDlg: Update List");
		
		MyBaseDlg::accept();
	}
	else
	{
		MyBaseDlg::reject();
	}
}

void ZAppSetting::reject()
{
	MyBaseDlg::reject();
} 
/*
void ZAppSetting::zCombBoxtextChanged()
{
    chang = true;
}*/

/**********************************************************************/
/**********************************************************************/
/*ZMyCheckBox::ZMyCheckBox(const QString & text, QWidget * parent, const char* name, bool value) : ZCheckBox ( text, parent, name ) {
    curState = value;
if (value)
	{
	    setState((ZBaseButton::ToggleState)2);
	}
	else
	{
	    setState((ZBaseButton::ToggleState)0);
	}
    connect (this,SIGNAL(toggled(bool)),this,SLOT(SetChecked(bool)));
}

ZMyCheckBox::~ZMyCheckBox()
{

}

void ZMyCheckBox::SetChecked(bool state)
{
    curState = state;
    chang = true;
}

bool ZMyCheckBox::GetChecked() const
{
     return curState;
}*/
