/**********************************************************
kMMenu for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/

#include <QWidget.h>
#include <ZConfig.h>
#include <qtimer.h>
#include <qpainter.h>
#include <vector>

struct kListBoxItem
{
	QString Name;
	QPixmap Icon;
	int 	Pid;
};

class kListBox : public QWidget
{
    Q_OBJECT

public:
    kListBox(int H);
    //~kOptionWidget();
	
	QPainter	p;
	QPixmap* 	bg_buf;
	QPixmap 	p_bg;
	QPixmap		cursor;
	
	//QCopChannel *cop;
	QCString copWidget;
	
	QString		skin_name;
	QColor		nameCol, nameCol_act/*, nameCol_unact*/, sbsCol, sbCol;
	int			nameSize, subNameSize;
	
	QFont	font;
	QFont	font_sub;
	QFont	font_act;
	QTimer*	timer;
	
	QString path;
	bool show_app;
	int animation, anim_delay, anim_key_delay;
	int animation_t, anim_delay_t, anim_key_delay_t;
	bool anim_enable, zebra_enable, cursor3d;
	int p_sb, p_sb2;
	int scroll_w, sb_w;
	int width, height;
	int w, h, h_vis, h_vis_s, h_vis_change;
	
	int scrollsize;
	int click_anim;
	
	int cur_it, it_c;
	
	int f_x, f_xx, f_chx, f_c;
	
	int cursor_h;
	bool quit;
	
	std::vector<kListBoxItem> listItem;

	void paint(int anim);
	void set_paints();
	bool up, down, launch;
	bool showPid;
	
	kListBoxItem item(int index) { return listItem[index]; }
	int getPid(int index) { return listItem[index].Pid; }
	QString getName(int index) { return listItem[index].Name; }
	QPixmap getIcon(int index) { return listItem[index].Icon; }
	
	int currentItem(){ return cur_it; }
	int count(){ return it_c; }
	
	void setCurrentItem(int curr_it);
	void addItem(kListBoxItem item);
	void addItem(QString name, QPixmap icon, int pid/*, int type*/);
	//void changeItem(kListBoxItem item);
	void changeItem(int id, QString name, QPixmap icon, int pid/*, int type*/);
	void removeItem(QString name);
	void removeItem(int i);
	void insertItem(kListBoxItem item, int id);
	void clear();
	
	void animEnable();
	
	void drawCursor();
	
	void delay(int msec);
	
	void readConfig();
	void readSkinCfg();
	QString kGetPath ( const char*ChineseString );
	
	void keyPressEvent(QKeyEvent *event);
	void keyReleaseEvent(QKeyEvent *event);
	void focusOutEvent(QFocusEvent* event);
	void focusInEvent(QFocusEvent* event);
	
	void sendHardKey(int key);
	
signals:
    void selected(int);
	/*void leftSoftKey();
	void rightSoftKey();
	void ClearKey();*/
	
public slots:
	void repaint();
	void showMenu();
	void hideMenu();
	void keyBoardProcess();
};
