/**********************************************************
kMMenu for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/

#include <QWidget.h>
#include <qcopchannel_qws.h>
#include <ZConfig.h>
#include <qtimer.h>
#include <qpainter.h>
#include <vector>

struct option_item
{
	QString Name;
	QCString Func;
	//QPixmap Icon;
	int Type;
};

class kOptionsMenu : public QWidget
{
    Q_OBJECT

public:
    kOptionsMenu(QCString CopWidget);
    //~kOptionsMenu();
	
	QPainter	p;
	QPixmap* 	bg_buf;
	QPixmap 	p_bg;
	QPixmap		cursor;
	
	//QCopChannel *cop;
	QCString copWidget;
	
	QString		skin_name;
	QColor		nameCol, nameCol_act, nameCol_unact, sbsCol, sbCol;
	int			nameSize;
	
	QFont	font;
	QFont	font_act;
	QTimer*	timer;
	
	QString path;
	bool show_app;
	int animation, anim_delay, anim_key_delay;
	int animation_t, anim_delay_t, anim_key_delay_t;
	bool anim_enable, cursor3d;
	int p_sb, p_sb2;
	int scroll_w, sb_w;
	int width, height;
	int w, h, h_vis, h_vis_s, h_vis_change;
	
	int scrollsize;
	int click_anim;
	
	int cur_it, it_c;
	
	int f_x, f_xx, f_chx, f_c;
	
	int cursor_h;
	bool quit;
	
	std::vector<option_item> optItem;

	void paint(int anim);
	void set_paints();
	bool up, down, launch;
	
	void addItem(QString name, QString func, /*QString icon, */int type);
	void changeItem(int id, QString name, QString func, /*QString icon,*/ int type);
	void delItem(int i);
	void clear();
	
	void animEnable();
	
	void drawCursor();
	
	void delay(int msec);
	
	void readConfig();
	void readSkinCfg();
	QString kGetPath ( const char*ChineseString );
	
	void keyPressEvent(QKeyEvent *event);
	void keyReleaseEvent(QKeyEvent *event);
	void focusOutEvent(QFocusEvent* event);
	void focusInEvent(QFocusEvent* event);
	
public slots:
	void runFunction();
	void repaint();
	void showOptionMenu();
	void hideOptionMenu();
	void keyBoardProcess();
};
