//
// C++ Implementation: ZTaskMan - lng file
//
// Description: task manager
//
//
// Author: Ant-ON <prozanton@gmail.com>, (C) 2009
//

#include <qobject.h>
#include <unistd.h>
#include <stdlib.h>

#include <ZListBox.h>
#include <ZComboBox.h>

class ZLng
{
  //Q_OBJECT
  public:
  	ZLng();
  	~ZLng();
  
	// Menu
	QString LNG_SHOW;
	QString LNG_QUIT;
	QString LNG_KILL;
	QString LNG_INFO;
	QString LNG_UPDATE;
	QString LNG_SETTING;
	QString LNG_ABOUT;
	QString LNG_EXIT;
	QString LNG_ADD;
	QString LNG_DEL;

	// SoftKey
	QString LNG_OK;
	QString LNG_MENU;
	QString LNG_CANCEL;
	QString LNG_SEL;

	//
	QString LNG_MINIALL;

	// Title
	QString LNG_DLG_ABOUT;
	QString LNG_DLG_SETTING;
	QString LNG_DLG_PROCINFO;
	QString LNG_DLG_ADD;

	//ZSettingDlg
	QString LNG_PROCFILTER;
	QString LNG_JAVAICON;
	QString LNG_PID;
	QString LNG_NATIVICON;
	QString LNG_TASKNOWIN;
	QString LNG_SENDREASEPHONE;
	QString LNG_SENDTOIDLE;
	QString LNG_UPDATEONRAISE;
	QString LNG_RUNICON;
	QString LNG_LANG;
	
	//ZProcInfo
	QString LNG_LOADLIB;
	
	QString ProgDir;
	
	void loadLngFile(QString fname, bool utf8 = true);
	void getLngList(/*ZComboBox *list*/QStringList list, QString cur);
	QString getLngFileName(QString lname);
};

//ZAboutDlg
#define LNG_VER "1.0"
//#define LNG_VER "for PE2"
#define LNG_THANKS "Thanks to Ant-ON for sources and permission for mod"
