//
// C++ Implementation: TestMain
//
// Description:
//
//
// Author: BeZ <bezols@gmail.com>, (C) 2008
//
// Copyright: See COPYING file that comes with this distribution
//
//
#include <KString.h>
#include "zTaskMan.h"
#include "lng.h"
#include "ZDefs.h"
#include "QDaemonApp.h"
#include <qcopchannel_qws.h>

ZTaskMan *zTaskMan;
QDaemonApp* app;
ZLng* lng;

#include <ZNoticeDlg.h>
#include <kInterface.h>
bool payChek()
{
	QCString chan = kActChan();
	
	if(QCopChannel::isRegistered(chan))
		return true;
	else
		return false;
}

int main ( int argc, char **argv )
{
  QDaemonApp a(argc, argv);
  
  if ( QCopChannel::isRegistered(ZTASKMAN_START) )
  {
  	QCopChannel::send( ZTASKMAN_START, "newshow()" );
	//QCopChannel::send( ZTASKMAN_START, "show()" );
  } else
  {
	app = new QDaemonApp(argc, argv);
	
	if(payChek())
	{
		lng = new ZLng();
		zTaskMan = new ZTaskMan();
		app->setMainWidget(zTaskMan);
		zTaskMan->hide();
		app->exec();
		delete lng;
		lng = NULL;   
		delete zTaskMan;
		zTaskMan = NULL;
	}
	else
	{
		ZNoticeDlg* dlg = new ZNoticeDlg((ZNoticeDlg::Type)0, QString("kTaskMan::Error"), QString("Please run kActivator before starting..\nMore info at http://e2.at.ua"), NULL, "Error", true, 0, false);
		app->setMainWidget(dlg);
		dlg->show();
		app->exec();
	}
  }
  delete app;
  app = NULL;
  return 0;
}
