/**********************************************************
kMMenu for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/
#include <qcopchannel_qws.h>
#include <KString.h>
#include <ZConfig.h>
#include "QDaemonApp.h"
#include "kMenuWidget.h"
#include <fcntl.h>
#include <linux/power_ic.h>
#include <sys/ioctl.h>
//#include <linux/ioctl.h>
//#include <stdio.h>
//#include <unistd.h>
#include <qmovie.h>
QMovie* gif;

bool	debug_;
QString	skin_name, wget, lang_name;
QString	path;

void Debug( QString print)
{
	if(debug_)
	qDebug("kMMenu::"+print);
}

QString lng_week, lng_month;
QString lng_Options, lng_Back, lng_Cancel, lng_Ok, lng_Move, lng_Take, lng_Finish;
QString lng_mrun, lng_move2dir, lng_reorder, lng_newdir, lng_del, lng_deldir, lng_move2sd, lng_move2phone, lng_rename, lng_renamedir, lng_add2klaunch, lng_chkupdate;
QString lng_error, lng_quit, lng_renaming, lng_removing, lng_resorting, lng_moving, lng_create_dir;
QString lng_write_dir_name, lng_cant_create_dir, lng_wrong_name, lng_move2dir_error, lng_del_error, lng_cant_find, lng_cant_rename, lng_add_error;
QString lng_resort_question, lng_rename_question, lng_remove_question, lng_remove_dir_question, lng_move_app_question[2], lng_move2dir_question, lng_quit_question;
QStringList lnga_id, lnga_name;

void readLang()
{
	Debug(QString("start read %1.lang").arg(lang_name));
	/*lng_mrun=tr("TXT_RID_HEADER_LAUNCH_APPLICATION",	"Launch application")+" by Id";	//"Запустить с повышенными правами"
	lng_move2dir=tr("TXT_RID_OPTION_MOVE_TO_FOLDER",	"Move to folder");		//"Переместить в папку"
	lng_reorder=tr("TXT_RID_OPTION_REORDER",			"Reorder");				//Пересортировать
	lng_newdir=tr("TXT_RID_OPTION_CREATE_NEW_FOLDER",	"New Folder");			//Новая папка
	lng_del=tr("TXT_RID_OPTION_REMOVE",					"Remove");				//"Удалить"
	lng_deldir=tr("TXT_RID_OPTION_DELETE_FOLDER",		"Delete folder");		//"Удалить папку"
	lng_move2sd=tr("TXT_RID_OPTION_MOVE_TO_CARD",		"Move to card");		//"Переместить на карту"
	lng_move2phone=tr("TXT_RID_OPTION_MOVE_TO_PHONE",	"Move to phone");		//"Переместить в телефон"
	lng_rename=tr("TXT_RID_OPTION_RENAME",				"Rename");				//"Переименовать"
	lng_renamedir=tr("TXT_RID_OPTION_RENAME_FOLDER",	"Rename folder");		//"Переименовать папку"
	lng_add2klaunch=tr("TXT_RID_OPTION_APPLY_TO",		"Apply to")+" kLaunch";	//"Добавить в kLaunch"*/
	
	ZConfig cfg(path+QString("lang/%1.lang").arg(lang_name), true);
	
	lng_mrun=cfg.readEntry("Options",				"LaunchById",		"Launch application by Id");//"Запустить с повышенными правами"
	lng_move2dir=cfg.readEntry("Options",			"MoveToFolder",		"Move to folder");			//"Переместить в папку"
	lng_reorder=cfg.readEntry("Options",			"Reorder",			"Reorder");					//Пересортировать
	lng_newdir=cfg.readEntry("Options",				"NewFolder",		"New Folder");				//Создать папку
	lng_del=cfg.readEntry("Options",				"Remove",			"Remove");					//"Удалить"
	lng_deldir=cfg.readEntry("Options",				"RemoveFolder",		"Remove folder");			//"Удалить папку"
	lng_move2sd=cfg.readEntry("Options",			"MoveToSdCard",		"Move to memory stick");	//"Переместить на карту памяти"
	lng_move2phone=cfg.readEntry("Options",			"MoveToPhone",		"Move to phone");			//"Переместить в телефон"
	lng_rename=cfg.readEntry("Options",				"Rename",			"Rename");					//"Переименовать"
	lng_renamedir=cfg.readEntry("Options",			"RenameFolder",		"Rename folder");			//"Переименовать папку"
	lng_add2klaunch=cfg.readEntry("Options",		"AddTokLaunch",		"Add to kLaunch");			//"Добавить в kLaunch"
	lng_chkupdate=cfg.readEntry("Options",			"CheckUpdate",		"Check update");			//"Проверить обновление"
///	
	lng_Options=cfg.readEntry("SoftKeys",			"Options",			"Options");					//"Параметры"
	lng_Back=cfg.readEntry("SoftKeys",				"Back",				"Back");					//"Назад"
	lng_Cancel=cfg.readEntry("SoftKeys",			"Cancel",			"Cancel");					//"Отмена"
	lng_Ok=cfg.readEntry("SoftKeys",				"Ok",				"Ok");						//"Ок"
	lng_Move=cfg.readEntry("SoftKeys",				"Move",				"Move");					//"Переместить"
	lng_Take=cfg.readEntry("SoftKeys",				"Take",				"Take");					//"Взять"
	lng_Finish=cfg.readEntry("SoftKeys",			"Finish",			"Finish");					//"Закончить"
///	
	lng_week=cfg.readEntry("InfoPanel",				"WeekLine",			"Mn|Tu|We|Th|Fr|Sa|Su")+"|";	//"Пн|Вт|Ср|Чт|Пт|Сб|Вс"
	lng_month=cfg.readEntry("InfoPanel",			"MonthLine",		"January|February|March|April|May|June|July|August|September|October|November|December")+"|";	//"Января|Февраля|Марта|Апреля|Мая|Июня|Июля|Августа|Сентября|Октября|Ноября|Декабря"
///	
	lng_error=cfg.readEntry("ShowDlg",				"Error",			"Error");					//Ошибка
	lng_quit=cfg.readEntry("ShowDlg",				"Quit",				"Quit");					//Выход
	lng_renaming=cfg.readEntry("ShowDlg",			"Renaming",			"Renaming");				//Переименовывание
	lng_removing=cfg.readEntry("ShowDlg",			"Removing",			"Removing");				//Удаление
	lng_resorting=cfg.readEntry("ShowDlg",			"Resorting",		"Resorting");				//Сортировка
	lng_moving=cfg.readEntry("ShowDlg",				"Moving",			"Moving");					//Перемещение
	lng_create_dir=cfg.readEntry("ShowDlg",			"CreatingFolder",	"Creating New Folder");		//Создание новой папки
	
	lng_write_dir_name=cfg.readEntry("ShowDlg",		"WriteFolderName",	"Enter new folder name:");	//Введите имя новой папки
	lng_cant_create_dir=cfg.readEntry("ShowDlg",	"CantCreateFolder",	"Can't create new folder");	//"Не удалось создать новую папку"
	lng_wrong_name=cfg.readEntry("ShowDlg",			"WrongName",		"You have written incorrectly or empty name");	//Вы ввели пустое или недопустимое имя
	lng_move2dir_error=cfg.readEntry("ShowDlg",		"MoveToFolderError","%1 already in folder %2");	//%1 и так находиться в папке %2
	lng_del_error=cfg.readEntry("ShowDlg",			"ErrorOfRemoving",	"Error removing of %1");	//Ошибка удаления %1
	lng_cant_find=cfg.readEntry("ShowDlg",			"CantFind",			"Can't find %1");			//%1 не удалось найти
	lng_cant_rename=cfg.readEntry("ShowDlg",		"CantRename",		"Can't rename %1");			//Не удалось переименовать %1
	lng_add_error=cfg.readEntry("ShowDlg",			"ErrorOfAdding",	"Error adding of %1");		//Ошибка добавления %1
	
	lng_resort_question=cfg.readEntry("ShowDlg",	"ResortQuestion",	"Do you want save changes?");//"Сохранить изменения?"
	lng_rename_question=cfg.readEntry("ShowDlg",	"RenameQuestion",	"Rename %1 to:");			//"Переименовать %1 на:"
	lng_remove_question=cfg.readEntry("ShowDlg",	"UnistallQuestion",	"Are you really want to unistall %1?");//Действительно деинсталировать %1?
	lng_remove_dir_question=cfg.readEntry("ShowDlg","RemoveFolderQuestion","Are you really want to remove folder %1?");//Действительно удалить папку %1?
	lng_move_app_question[0]=cfg.readEntry("ShowDlg","MovePhoneAppQuestion", "Are you really want to move %1 to SD Card?");//Вы действительно хотите переместить %1 на карту памяти?
	lng_move_app_question[1]=cfg.readEntry("ShowDlg","MoveSdAppQuestion", "Are you really want to move %1 to phone memory?");//Вы действительно хотите переместить %1 в память телефона?
	lng_move2dir_question=cfg.readEntry("ShowDlg",	"MoveToFolderQuestion",	"Are you really want to move %1 to %2?");//Действительно переместить %1 в папку %2?
	lng_quit_question=cfg.readEntry("ShowDlg",		"QuitQuestion",		"Are you sure want close kMMenu?");//Вы действительно хотите закрыть kMMenu?
	
	//lnga_main_menu=cfg.readEntry("AppName",			"MainMenu",			"Main Menu");				//"Главное меню"
	QString app_line=cfg.readEntry("AppName",			"AppsIdForChangeName",	"")+"|";
	int pos=0;lnga_id.clear();lnga_name.clear();
	pos = app_line.find("|");
	while(pos!=-1)
	{
		lnga_id.append(app_line.left(pos));
		app_line.remove(0, pos+1);
		pos = app_line.find("|");
	}
	for(int i=0;i<(int)lnga_id.count();i++)
	{
		lnga_name.append(cfg.readEntry("AppName", lnga_id[i], ""));
	}
	
	cfg.flush();
	Debug("finish read lang");
}

void readMainConfig()
{
	ZConfig cfg(path+"/kMMenu.cfg", true);
	debug_=atoi(cfg.readEntry("Setting", "PrintLog", "0"));
	skin_name="skin/"+cfg.readEntry("Setting", "Skin", "default");
	wget=cfg.readEntry("Setting", "WgetLine", "busybox wget -O %1 %2");
	lang_name=cfg.readEntry("Setting", "Language", "english");
	readLang();
	cfg.flush();
}

void vibrate(int duration, int level)
{
	if(duration>0)
	{
		int power_ic = open("/dev/" POWER_IC_DEV_NAME, O_RDWR);
		if(power_ic == -1) 
		{
			close(power_ic);
			return;
		}
		
		ioctl(power_ic, POWER_IC_IOCTL_PERIPH_SET_VIBRATOR_LEVEL, level); 
		ioctl(power_ic, POWER_IC_IOCTL_PERIPH_SET_VIBRATOR_ON, POWER_IC_PERIPH_ON);
		usleep(duration);
		ioctl(power_ic, POWER_IC_IOCTL_PERIPH_SET_VIBRATOR_ON, POWER_IC_PERIPH_OFF);
		close(power_ic);
	}
}


Registry* phonedb;
Registry* carddb;
Registry* sysdb;
Registry* userdb;
QDaemonApp* a;

#include <ZNoticeDlg.h>
#include <kInterface.h>
bool payChek()
{
	QCString chan = kActChan();
	
	if(QCopChannel::isRegistered(chan))
		return true;
	else
		return false;
}

int main(int argc, char **argv)
{
	QDaemonApp app(argc, argv);
	if (QCopChannel::isRegistered("kMMenu"))
	{
		QCopChannel::send("kMMenu", "switch");
		//system(kGetPath(argv[0])+"qcop_send kMMenu switch&");
		Debug("kMMenu::send mes");
	}
	else
	{
		path=kGetPath(argv[0]);
		a = new QDaemonApp(argc, argv);
		
		if(payChek())
		{
			readMainConfig();
			
			phonedb = new Registry(PHONE_REG, "/ezxlocal/.system/");
			carddb = new Registry(MMC_REG, "/mmc/mmca1/.system/");
			sysdb = new Registry(SYS_REG, "/usr/SYSqtapp/");
			userdb = new Registry(USER_REG, "/usr/SYSqtapp/");
			
			kMenuWidget* mainMenu = new kMenuWidget("MainMenu");
			///kIconGrid* mainMenu = new kIconGrid("MainMenu");
			///mainMenu->readMainMenu();
			//mainMenu->readItemsCfg(ILAUNCH_REG, "ILaunch");
			mainMenu->hide();
			a->exec();
		}
		else
		{
			/*ZNoticeDlg* dlg = new ZNoticeDlg((ZNoticeDlg::Type)0, "kMMenu::Error", "Please run kActivator before starting..\nMore info at http://e2.at.ua", NULL, "Error", true, 0, false);*/
			kShowDlg* dlg = new kShowDlg();
			a->setMainWidget(dlg);
			lng_Ok="Ok";
			dlg->Show("kMMenu::Error", "Please run kActivator before starting..\nMore info at http://e2.at.ua", 0);
			a->exec();
		}
	}
	return 0;
}
