/**********************************************************
kMMenu for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/
#include <RES_ICON_Reader.h>
#include <qtextstream.h>
#include <ZConfig.h>

#include <vector>
#include <qfile.h>
#include <qimage.h>


#define UserMenuTree "/ezx_user/download/appwrite/am/UserMenuTree"

//#define SYS_REG "/usr/SYSqtapp/am/SysRegistry"
#define MMC_REG "/mmc/mmca1/.system/java/CardRegistry"
#define PHONE_REG "/ezx_user/download/appwrite/am/InstalledDB"
#define SYS_REG "/usr/data_resource/preloadapps/SysRegistry"
#define USER_REG "/ezx_user/download/appwrite/am/UserRegistry"

#define MainMenuId "2a58c0d6-05c6-45aa-8938-63059d41a4e9"

/*
struct registry_structure
{
	QString id;
	QString name;
	QString icon;
	QString exec;
	QString appid;
	QString path;
	int place;
	int type;
};*/

struct data_struct
{
	QString Id;
	QString Name;
	QString icon;
	QPixmap Icon;
	QPixmap BigIcon;
	QString AniIcon;
	QString Exec;
	QString AppId;
	QString Path;
	int Place;
	int Type;
};

class Registry
{
	public:
	
	Registry(QString openfile, QString path);
	
	int total;
	int error;
	int bicon_size, icon_size;
	RES_ICON_Reader r;
	std::vector<data_struct> data;
	QString regfile;
	QString it_path;
	bool search(data_struct &regdata, QString searchid);
	void rename(QString id, QString name);
	void remove(QString id);
	void add(data_struct dat);
	void search_add(QString id);
	QString kGetMime(const char*ChineseString);
	void update();
	void setIconSize(int s, int b);
};
