#define SYS_REGISTRY "/usr/data_resource/preloadapps/SysRegistry"
#define CARD_REGISTRY "/mmc/mmca1/.system/java/CardRegistry"
#define USER_REGISTRY "/ezxlocal/download/appwrite/am/UserRegistry"
#define INSTALLED_DB "/ezxlocal/download/appwrite/am/InstalledDB"

#define EZXQTSERVER_CHANNEL "EZX/QtServer"
#define SYSTEM_CHANNEL "EZX/System"
#define SYS_SETUP_CHANNEL "/systemsetup/broadcast"
#define launcherChannel     "/AM/Launcher"

#define MSG_SLIDER_OPENED "sliderOpened"
#define MSG_SLIDER_CLOSED "sliderClosed"

#define APP_CHANNEL_PREF "EZX/Application/"

#define RETURN_IDLE_EVENT            5678
#define RETURN_IDLE_BY_END_KEY       -5000
#define RETURN_IDLE_BY_FLIP          -5001
#define RETURN_IDLE_BY_APP_TIMEOUT   -5002
#define RETURN_IDLE_BY_SLIDER        -5003

#define Z6KEY_RED               0x1031

#define appConf "/kTaskMan.cfg"
//#define appConfName "/PE_zTaskMan.ru.cfg"

#define ZTASKMAN_START "kTaskMan"

//#define SDL_LIB_CHENEL "PE/SDLLib/"

#define SCREEN_WHIDTH 240

class ZReturnIdleEvent : public QCustomEvent
{
	public:
		ZReturnIdleEvent( int nReason )
			: QCustomEvent( RETURN_IDLE_EVENT),
			accepted ( true ) { reason = nReason; }
 
		void reject() { accepted = false; }
 
		void accept() { accepted = true; }
		bool isAccepted() const { return accepted; }
 
		int getReason( ) const { return reason; };
 
	private:
		int reason;
		bool accepted;
};
