/**********************************************************
kMMenu for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/
#include "kIconGrid.h"
#include "QDaemonApp.h"
///#include <AM_LauncherInterface.h>
#include "ZMsg.h"
//#include "exec.h"

extern QDaemonApp* a;

extern Registry* phonedb;
extern Registry* carddb;
extern Registry* sysdb;
extern Registry* userdb;

extern QString UTF( const char*ChineseString );
extern QString kGetPath( const char*ChineseString );

extern void Debug( QString print);

extern void vibrate(int duration, int level);

extern QString path, skin_name, wget, lang_name;

extern QString lng_mrun, lng_move2dir, lng_reorder, lng_newdir, lng_del, lng_deldir, lng_move2sd, lng_move2phone, lng_rename, lng_renamedir, lng_add2klaunch, lng_chkupdate;
extern QString lng_error, lng_quit, lng_renaming, lng_removing, lng_resorting, lng_moving, lng_create_dir, lng_write_dir_name, lng_cant_create_dir, lng_wrong_name, lng_move2dir_error, lng_del_error, lng_cant_find, lng_cant_rename, lng_add_error, lng_resort_question, lng_rename_question, lng_remove_question, lng_remove_dir_question, lng_move_app_question[2], lng_move2dir_question, lng_quit_question;
extern QStringList lnga_id, lnga_name;
extern QString lng_Options, lng_Back, lng_Cancel, lng_Move, lng_Take, lng_Finish;

kIconGrid::kIconGrid(QString cfg_name) : 
    QWidget(NULL, "ZMainWidget")
{
	cfgname=cfg_name;
	
	left=right=up=down=launch=launch_run=false;
	inFocus=false;
	Resort=MoveToDir=false;
	quit=false;
	anim_act_jump=0;anim_act_jump_c=1;
	font=QFont(NULL, 10, 25, false);
	font_act=font;

	api= new SETUP_API();//ЗАМЕНИТЬ
	api->getWallpaper(Wallpaper);//ЗАМЕНИТЬ
	
	ses = new ZDataSessionManager();
	ses->init();
	
	//width=240;height=320;
	setBackgroundMode(NoBackground);
	//setFullScreenMode(width, height);
	//resize(240, 320);
	//move(0, 0);

	bg_buf = new QPixmap(240, 320);
	
	options = new kOptionsMenu();
	options->hideOptionMenu();
	showDlg = new kShowDlg();
	showDlg->hide();
	
	readSkinCfg();
	
	p.begin( bg_buf ,this);
	
	//iconGrid = new kIconGrid(240, 320);
	//iconGrid->move(0, 0);
	
	timer = new QTimer(this);
	connect( timer, SIGNAL(timeout()), SLOT(keyBoardProcess()) );
	connect( a, SIGNAL(signalRaise()), this, SLOT(showMenu()) );
	connect( qApp, SIGNAL(signalRaise()), this, SLOT(showMenu()) );
	connect(options, SIGNAL(select(QString)), this, SLOT(slotOptionsSelected(QString)) );

	connect(ses, SIGNAL(connected(int, ZLinkInfo&)), this, SLOT(connected()));
	connect(ses, SIGNAL(openFailed(int, unsigned short, unsigned short)), this, SLOT(connect_f()));

	//set_paints();
	//QTimer::singleShot(100, this, SLOT(showMenu()));
}
/*
kIconGrid::~kIconGrid()
	{
	}*/
	
void kIconGrid::showMenu()
{
	//emit changeFocus(true);
	paint(0);
	show();
	//a->slotRaise();
}

void kIconGrid::hideMenu()
{
	emit fullHide();
	left=right=up=down=false;
	launch=false;
	options->hideOptionMenu();
	timer->stop();
	hide();
}

void kIconGrid::set_paints()
{
	scroll_w=sb_w+2;
	
	cur_i=cur_j=0;
	but_size=(width-scroll_w-(w+1)*hpading)/w;		
	h_vis=(height)/(vpading+nameSize_act+but_size);
	h_vis_s=h_vis_change=0;
	bicon_size=but_size*bicon_p/100;
	icon_size=but_size*icon_p/100;
	bcenter=(but_size-bicon_size)/2;
	center=(but_size-icon_size)/2;
	
	phonedb->setIconSize(icon_size, bicon_size);
	carddb->setIconSize(icon_size, bicon_size);
	sysdb->setIconSize(icon_size, bicon_size);
	userdb->setIconSize(icon_size, bicon_size);
	
	cursor=QPixmap(but_size, but_size);
	cursor.convertFromImage(QImage(path+skin_name+"/cursor.png").smoothScale(but_size, but_size));
}

void kIconGrid::paint(int anim)
{
	int x_anim=0, y_anim=0, x_anim_c=0, y_anim_c=0, y_anim_i=0,d=1, anim_step=0;
	
	if(transparency_bg)
	{
		QString wallpaper;
		api->getWallpaper(wallpaper);//ЗАМЕНИТЬ
		if(Wallpaper!=wallpaper)
		{
			Wallpaper=wallpaper;
			refreshBg();
		}
	}
	
	if(anim)
	{
		if(left) {d=1;}
		if(right) {d=-1;}
		if(up) {d=1;}
		if(down) {d=-1;}
		anim_step=but_size/(anim+1);
		
		if(left|right)
			x_anim=but_size+hpading-anim_step;
		else
			y_anim=but_size+vpading-anim_step;
	}
	do
	{
		//anim_obj_set
		if(h_vis_change==h_vis_s)
		{
			x_anim_c=x_anim;
			y_anim_c=y_anim;
			y_anim_i=0;
		}
		else
		{
			y_anim_i=y_anim;
			y_anim_c=x_anim_c=0;
		}
		
		//bg
		p.drawPixmap(-x, -y, bg_tmp);
		
		//scroll
		int s_size=h-h_vis;	if(s_size<1)s_size=1;
		int scroll=h_vis_change*(height-2-scrollsize)/(s_size);
		
		p.setPen(sbsCol);
		p.drawRect(width-(sb_w+2), 0, sb_w+2, height);
		p.setPen(sbCol);
		p.fillRect(width-(sb_w+1), 1+scroll, sb_w, scrollsize, QBrush(sbCol));
		
		//cursor
		int cur_x=hpading+(hpading+but_size)*cur_i;
		int cur_y=vpading+(vpading+nameSize_act+but_size)*(cur_j-h_vis_s);
		p.drawPixmap(cur_x+x_anim_c*d, cur_y+y_anim_c*d, cursor);
		
		//icons
		for(int i=0; i<w; i++)
		{
			int anim_line_down=0;
			if(down && h_vis_s>0)
				anim_line_down=-1;
			for(int j=h_vis_s+anim_line_down; j<(h_vis+h_vis_s+1); j++)
			{
				int index=i+w*j;
				if(index>=it_c || quit)
					break;
				int x=hpading+(hpading+but_size)*i;
				int y=vpading+(vpading+nameSize_act+but_size)*(j-h_vis_s)+y_anim_i*(-d);
				int c=center;
				int f_h=nameSize;
				QFont f;
				if(index==curItem)
				{
					if(nameSize_act>0)
					{
						p.setPen(nameCol_act);
						p.setFont(font_act);
						f_h=nameSize_act;
						f=font_act;
					}
					
					if(!launch)
					{
						c=bcenter;
						//p.drawImage(x+c, y+c, data[index].BigIcon.convertToImage().smoothScale(bicon_size, bicon_size));
						p.drawPixmap(x+c, y+c-anim_act_jump, /**hsIcon*/data[index].BigIcon);
					}
					else
						//p.drawImage(x+c, y+c, data[index].BigIcon.convertToImage().smoothScale(icon_size, icon_size));
						p.drawPixmap(x+c, y+c, data[index].Icon);
					
				}
				else
				{
					if(nameSize_act>0)
					{
						p.setPen(nameCol);
						p.setFont(font);
						f=font;
					}
					
					//p.drawImage(x+c, y+c, data[index].BigIcon.convertToImage().smoothScale(icon_size, icon_size));
					p.drawPixmap(x+c, y+c, data[index].Icon);
				}
				if(nameSize_act>0)
				{
					QFontMetrics fm(f);
					int leight_name=fm.width(data[index].Name);
					if(leight_name>but_size)
						p.drawText(x, y+but_size, but_size, f_h+5, Qt::AlignLeft|Qt::AlignTop, data[index].Name, -1);
					else
						p.drawText(x, y+but_size, but_size, f_h+5, Qt::AlignHCenter|Qt::AlignTop, data[index].Name, -1);
				}
			}
		}
		
		repaint();
		
		//anim_check
		anim--;
		if(anim<=0)
		{
			if(left|right)
				x_anim=0;
			else
				y_anim=0;
			h_vis_change=h_vis_s;
		}
		else
		{
			if(left|right)
				x_anim=x_anim-anim_step;
			else
				y_anim=y_anim-anim_step;
		}
		delay(anim_delay);
	}
	while(anim>=0 && !quit);
	//delay(anim_key_delay);
}

void kIconGrid::repaint()
{
	bitBlt( this, 0, 0, bg_buf );
	Debug(QString("repaint"));
}

void kIconGrid::keyBoardProcess()
{
	qApp->processEvents();
	if(data[0].Exec!="")
	{
		if(left)	cur_i=(cur_i+w-1)%w;
		if(right)	cur_i=(++cur_i)%w;
		if(up)		cur_j=(cur_j+h-1)%h;
		if(down)	cur_j=(++cur_j)%h;
	
		mrun();
		
		if(left||right||up||down)
		{
			curItem=cur_i+w*cur_j;
			///hsIcon=data[curItem].BigIcon;
			while(curItem>=it_c)
			{
				if(right)
					cur_i=(++cur_i)%w;
				else
					cur_i=(cur_i+w-1)%w;
				//cur_i--;//
				curItem=cur_i+w*cur_j;
			}
			if(cur_i<0)cur_i=0;
			
			h_vis_s=(cur_j+1)-h_vis;
			if(h_vis_s<0)h_vis_s=0;
			/*
			if(!down && h_vis_s!=0 && cur_j!=h-1)
			{
				if((h_vis-h_vis_s)!=cur_j)h_vis_s=h_vis_change;
			}*/
			
			anim_act_jump=0; anim_act_jump_c=1;
			anim_act_gif_upd=true;
			
			if(vibro_type)
				vibrate(vibr_duration, vibr_level);
			
			paint(animation);
			emit updateActiveItem();
		}
		else
		{
			if(anim_enable && anim_act_gif)
			{
				if(anim_act_gif_upd)
				{
					if(gif)
					{
						gif->disconnectUpdate(this, SLOT(gifUpdated()));
						delete gif;
						gif=NULL;
					}
					gif = new QMovie(data[curItem].AniIcon);
					gif->connectUpdate(this, SLOT(gifUpdated()));
					anim_act_gif_upd=false;
				}
			}
		
			if(anim_enable && anim_act_jump_t!=0)
			{
				anim_act_jump=anim_act_jump+anim_act_jump_c;
				if(anim_act_jump==0 || anim_act_jump==anim_act_jump_t)
					anim_act_jump_c=-anim_act_jump_c;
				paint(0);
			}
			else
				anim_act_jump=0;
		}
	}
	Debug(QString("cursor pos %1x%2").arg(cur_i).arg(cur_j));
}

void kIconGrid::gifUpdated()
{
	hsIcon=gif->framePixmap();
}

void kIconGrid::keyPressEvent(QKeyEvent *event)
{
	//printf("KEY: %x\n", event->key());
	switch (event->key())
	{
		case 0x1004: //	Center
			if(Resort)
				ChangePos();
			else
			{
				if(!launch && !launch_run && data[0].Exec!="")
				{
					launch=true;
					run_c=10;
					Debug("press launch");
					paint(0);
				}
			}
		break;
		
		case 0x1014: //	Right
			right=true;
		break;
		case 0x1012: //	Left
			left=true;
		break;
		case 0x1013: //	Up
			up=true;
		break;
		case 0x1015: //	Down
			down=true;
		break;
		
		case 0x1030: // Green
			if(showDlg->Show(lng_quit, lng_quit_question, 2))
			{
				quit=true;
				qApp->quit();
			}
		break;
		/*
		case 0x1031: //	Red
			hideMenu();
		break;*/
		
		case 0x1038: //	LeftSoft
			if(!MoveToDir && !Resort)
				showOptions();
			if(MoveToDir)
			{
				if(m2d_path==curId)
					showDlg->Show(lng_error, lng_move2dir_error.arg(m2d.Name).arg(activePath()), 0);
				else
				{
					if(showDlg->Show(lng_moving, lng_move2dir_question.arg(m2d.Name).arg(activePath()), 2))
						Move2Dir();
					MoveToDir=false;
					changeSoftKeys(NULL, NULL);
				}
			}
			if(Resort)
				ChangePos();
		break;
		
		case 0x103a: //	RightSoft
			if(!MoveToDir && !Resort)
			{
				if(curId==MainMenuId)
					hideMenu();
				else
					readMainMenu();
			}
			if(MoveToDir)
			{
				MoveToDir=false;
				changeSoftKeys(NULL, NULL);
			}
			if(Resort)
			{
				if(resort_line!=resort_line_b)
				{
					ZConfig cfg(UserMenuTree, true);
					if(showDlg->Show(lng_resorting, lng_resort_question, 2))
						cfg.writeEntry(curId, "Items", resort_line);
					else
					{
						cfg.writeEntry(curId, "Items", resort_line_b);
						readItemsCfg(UserMenuTree, curId);
					}
					cfg.flush();
				}
				Resort=false;
				changeSoftKeys(NULL, NULL);
			}
		break;
		
		case 0x1032: //	c
			if(!Resort)
				readMainMenu();
		break;
		
		case 4172: // Key Next
			if(QCopChannel::isRegistered("SVKPlayer"))
				QCopChannel::send("SVKPlayer", "next");
			else
				sendHardKey(4172);
		break;
		case 4171: //	Key Prew
			if(QCopChannel::isRegistered("SVKPlayer"))
				QCopChannel::send("SVKPlayer", "prew");
			else
				sendHardKey(4171);
		break;
		case 4169: //	Key Play
			if(QCopChannel::isRegistered("SVKPlayer"))
				QCopChannel::send("SVKPlayer", "show");
			else
				sendHardKey(4169);
		break;
		
		case 0x1016: //	VolumeUp
			up=true;
		break;
		case 0x1017: //	VolumeDown
			down=true;
		break;
		
		case 48:
			updateReg();
			if(skin_name!="skin/")
			{
				readSkinCfg();
				readItemsCfg(UserMenuTree, curId);
			}
		break;
		
		case 42://	*
			anim_enable=!anim_enable;
			animEnable();
		break;
		
		case 35:
			QCopChannel::send("kMMenu", "changeSkin");
		break;
		
		default:
		break;
	}
}
	
void kIconGrid::keyReleaseEvent(QKeyEvent *event)
{
	switch (event->key())
	{
		case 0x1004:
			if(launch)
			{
				vibrate(vibr_launch_duration, vibr_launch_level);
				
				launch=false;
				anim_act_jump=0;anim_act_jump_c=1;
				if(data[curItem].Type==1)
				{
					readItemsCfg(UserMenuTree, data[curItem].Id);
				}
				else
				{
					run(data[curItem].AppId);
					
					paint(0);
				}
			}
			launch_run=false;
			run_c=0;
		break;
		
		case 0x1014: //	Right
			if(!vibro_type)
				vibrate(vibr_duration, vibr_level);
			right=false;
		break;
		case 0x1012: //	Left
			if(!vibro_type)
				vibrate(vibr_duration, vibr_level);
			left=false;
		break;
		case 0x1013: //	Up
			if(!vibro_type)
				vibrate(vibr_duration, vibr_level);
			up=false;
		break;
		case 0x1015: //	Down
			if(!vibro_type)
				vibrate(vibr_duration, vibr_level);
			down=false;
		break;
		
		case 0x1016: //	VolumeUp
			if(!vibro_type)
				vibrate(vibr_duration, vibr_level);
			up=false;
		break;
		case 0x1017: //	VolumeDown
			if(!vibro_type)
				vibrate(vibr_duration, vibr_level);
			down=false;
		break;
		
		default:
		break;
	}
}

void kIconGrid::sendHardKey(int key)
{
	QByteArray data;
	QDataStream stream(data, IO_ReadOnly);
	stream << key << 1;
	QCopChannel::send(QCString("/hardkey/bc"), QCString("keyMsg(int,int)"), data);
}
	
void kIconGrid::run(QString id)
{
	Debug("Run id:"+id);
	QString run="{"+id+"}";
	///AM_LauncherInterface::launchApp((QUuid)run,false);
	ZMsg msg( "/AM/Launcher", "launchApp4NoLockCheck" ); ///launchAppWithUid
	msg << (QUuid)run;
	msg.send();
}


void kIconGrid::mrun()
{
	if(launch)
	{
		if(data[curItem].Type!=1)
		{
			if(run_c<=0)
			{
				paint(0);
				Debug(data[curItem].Exec);
				system(data[curItem].Exec+"&");
				///sysexec sc;
				///QString run=data[curItem].Exec;
				///sc.exec(run);
				launch=false;
				launch_run=true;
				paint(0);
			}
			else
				run_c--;
			Debug("mRun:"+data[curItem].Exec);
		}
	}
	else
		run_c=0;
}

void kIconGrid::animEnable()
{
	if(anim_enable)
	{
		animation=animation_t;
		anim_delay=anim_delay_t;
		anim_key_delay=anim_key_delay_t;
	}
	else
	{
		animation=0;
		anim_delay=0;
		anim_key_delay=100;
	}
	anim_act_jump=0;anim_act_jump_c=1;
	
	ZConfig cfg(path+skin_name+QString("/%1.ini").arg(cfgname), true);
	cfg.writeEntry("Setting", "AnimationEnable", QString("%1").arg(anim_enable));
	cfg.flush();
}

void kIconGrid::updateReg()
{
	phonedb->update();
	carddb->update();
	sysdb->update();
	userdb->update();
}
	
void kIconGrid::readMainMenu()
{
	readItemsCfg(UserMenuTree, MainMenuId);
}
	
void kIconGrid::readSkinCfg()
{
	//int tmp=0;
	//QString col="";
	
	ZConfig cfg(path+skin_name+QString("/%1.ini").arg(cfgname), true);
	
	x=cfg.readNumEntry("Geometry", "PosX", 0);
	y=cfg.readNumEntry("Geometry", "PosY", 0);
	width=cfg.readNumEntry("Geometry", "Width", 240);
	height=cfg.readNumEntry("Geometry", "Height", 300);
	
	transparency_bg=cfg.readBoolEntry("Setting", "TransparencyBg", false);
	anim_enable=cfg.readBoolEntry("Setting", "AnimationEnable", true);
	animation_t=cfg.readNumEntry("Setting", "Animation", 2);
	if(animation_t<1)animation_t=1;
	anim_delay_t=cfg.readNumEntry("Setting", "AnimationDelay", 1);
	if(anim_delay_t<1)anim_delay_t=1;
	anim_key_delay_t=cfg.readNumEntry("Setting", "AnimationKeyDelay", 100);
	if(anim_key_delay_t<1)anim_key_delay_t=100;
	anim_act_jump_t=cfg.readNumEntry("Setting", "AnimationIconJump", 0);
	if(anim_act_jump_t<0)anim_act_jump_t=0;
	anim_act_gif=cfg.readBoolEntry("Setting", "AnimationIcon", false);
	vibro_type=cfg.readBoolEntry("Setting", "VibrateType", false);
	vibr_duration=cfg.readNumEntry("Setting", "VibrateDuration", 0);
	if(vibr_duration<0)vibr_duration=0;
	vibr_level=cfg.readNumEntry("Setting", "VibrateLevel", 0);
	if(vibr_level<0)vibr_level=0;if(vibr_level>3)vibr_level=3;
	vibr_launch_duration=cfg.readNumEntry("Setting", "VibrateLaunchDuration", 0);
	if(vibr_launch_duration<0)vibr_launch_duration=0;
	vibr_launch_level=cfg.readNumEntry("Setting", "VibrateLaunchLevel", 0);
	if(vibr_launch_level<0)vibr_launch_level=0;if(vibr_launch_level>3)vibr_launch_level=3;
	
	w=cfg.readNumEntry("Icons", "HNums", 3);
	hpading=cfg.readNumEntry("Icons", "HPading", 10);
	vpading=cfg.readNumEntry("Icons", "VPading", 4);
	bicon_p=cfg.readNumEntry("Icons", "BigIconPercent", 85);
	icon_p=cfg.readNumEntry("Icons", "IconPercent", 70);
	
	sbsCol=cfg.readEntry("ScrollBar", "BgColor", "#000000");
	sbCol=cfg.readEntry("ScrollBar", "Color", "#ffffff");
	sb_w=cfg.readNumEntry("ScrollBar", "ScrollWidth", 1);
	
	nameSize=cfg.readNumEntry("FontIconName", "Size", 9);
	nameCol=cfg.readEntry("FontIconName", "Color", "#ffffff");
	if(cfg.readBoolEntry("FontIconName", "Enable", true))
		nameSize_act=atoi(cfg.readEntry("FontIconName", "ActiveSize", "0"));
	else
		nameSize_act=0;
	nameCol_act=cfg.readEntry("FontIconName", "ActiveColor", "#ffffff");
	cfg.flush();
	
	font.setPixelSize(nameSize);
	font_act.setPixelSize(nameSize_act);
	
	api->getWallpaper(Wallpaper);//ЗАМЕНИТЬ
	
	p_bg.load(path+skin_name+"/bg.png");
	w_bg.load(Wallpaper);
	bg_tmp = QPixmap(240, 320);
	
	resize(width, height);
	move(x, y);
	//bg_buf->resize(width, height);
	//qDebug("icon resize ok");
	
	animEnable();
	set_paints();
	refreshBg();
	
	options->readSkinCfg();
	showDlg->readSkinCfg();
}

void kIconGrid::readItemsCfg(QString file, QString ID)
{
	curItem=cur_j=cur_i=it_c=0;int i=0;
	curId=ID;
	QStringList ItemsList;
	QString items;
	ZConfig cfg(file, true);
	
	items=cfg.readEntry(ID, "Items", "");
	cfg.flush();
	while(i!=-1)
	{
		/*i = items.findRev(";");
		if(i!=items.length()-1)
		{
			ItemsList.append(items.right(items.length()-i-1));
		}
		items.remove(i, items.length()-i);*/
		i = items.find(";");
		if(i!=1)
		{
			ItemsList.append(items.left(i));
		}
		items.remove(0, i+1);
	}
	data.clear();
	if(!ItemsList[0].isNull())
	{
		//Debug(QString("cfg %1 %2").arg(ItemsList.count()).arg(ItemsList[0]));
		for(int index=0; index<(int)ItemsList.count(); index++)
		{
			data_struct tmp;
			if(userdb->search(tmp, ItemsList[index]) || phonedb->search(tmp, ItemsList[index]) 
			|| carddb->search(tmp, ItemsList[index]) || sysdb->search(tmp, ItemsList[index]))
			{
				data.push_back(tmp);
				//Debug(QString("Id:%1 ").arg(it_c)+"itemName:"+data[it_c].Name+" itemExec:"+data[it_c].Exec/*+" BigIcon:"+tempIcon*/);
				it_c++;
			}
		}
		h=it_c/w;
		if(it_c%w!=0)
			h++;
		scrollsize=h_vis*(height-2)/h;
		h_vis_s=(cur_j+1)-h_vis;
		if(h_vis_s<0)h_vis_s=0;
	}
	else
		{it_c=0;h=1;h_vis_s=0;data[0].Exec="";}
	
	paint(1);
	emit updateActivePath();
	emit updateActiveItem();
}

void kIconGrid::refreshBg()
{
	QPainter bg;
	w_bg.load(Wallpaper);
	bg.begin(&bg_tmp, this);
	bg.drawPixmap(0, 0, w_bg);
	bg.drawPixmap(0, 0, p_bg);
	bg.end();
	Debug("refreshBg");
}

void kIconGrid::focusOutEvent(QFocusEvent * )
{
	emit changeFocus(false);
	inFocus=false;
	Debug("focus out");
	left=right=up=down=false;
	launch=false;
	timer->stop();
}

void kIconGrid::focusInEvent(QFocusEvent * )
{
	Debug("in focus");
	emit changeFocus(true);
	inFocus=true;
	timer->start(anim_key_delay);
	QTimer::singleShot(100, this, SLOT(repaint()));
	//showMenu();
}

void kIconGrid::delay(int msec)
{
	struct timespec elapsed, tv;
	elapsed.tv_sec = msec/1000;
	elapsed.tv_nsec = (msec%1000)*1000000;
	tv.tv_sec = elapsed.tv_sec;
	tv.tv_nsec = elapsed.tv_nsec;
	nanosleep(&tv, &elapsed);
}
/*	
void kIconGrid::slotQCopReceived(const QCString &msg)
{
	Debug("reseive mes "+msg);
	//if(!inFocus)	showMenu();
	//else			hideMenu();
	if(msg=="switch" || msg=="SHOWMAINMENU")
	{
		showMenu();//
	}
}*/

void kIconGrid::changeSoftKeys(QString left_soft, QString right_soft)
{
	if(left_soft=="" && right_soft=="")
	{
		left_soft=lng_Options;
		right_soft=lng_Back;
	}
	Debug("change softkeys name to "+left_soft+" & "+right_soft);
	emit changeSoftKeysName(left_soft, right_soft);
}

///######################## Options ##########################
	
void kIconGrid::showOptions()
{
	int onum=9;
	//Application Menu
	QString name[9]={
	lng_mrun,
	lng_move2dir,
	lng_reorder,
	lng_newdir,
	lng_del,
	lng_move2sd,
	lng_rename,
	lng_add2klaunch,
	lng_chkupdate
	};	
	QString func[9]={"mlaunch", "moveToDir", "reSort", "newDir", "delApp", "moveApp", "renameApp", "addklaunch", "chkUpdate"};
	
	//Dirs Menu
	QString name1[6]={
	lng_move2dir,
	lng_reorder,
	lng_newdir,
	lng_renamedir,
	lng_deldir,
	lng_chkupdate
	};
	QString func1[6]={"moveToDir", "reSort",  "newDir", "renameDir", "delDir", "chkUpdate"};
	
	if(data[curItem].Type==1)
		onum=6;
	
	options->clear();
	
	for(int i=0;i<onum;i++)
	{
		if(data[curItem].Type==1)
		{
			options->addItem(name1[i], func1[i], 2);
			if(!data[curItem].Place && (i==3 || i==4))
				options->changeItem(i, NULL, NULL, 1);
		}
		else
		{
			options->addItem(name[i], func[i], 2);
			if(!data[curItem].Place && (i==4 || i==5 || i==6))
			{
				options->changeItem(i, NULL, NULL, 1);
			}
			if(data[curItem].Place==3 && i==5)
				options->changeItem(i, lng_move2phone, NULL, 2);
		}
	}
	options->showOptionMenu(320-height-y);
}

void kIconGrid::slotOptionsSelected(QString func)
{
	//showDlg->Show(UTF("Выполнение функции"), func, 1);
///	Запустить с повышенными правами
	if(func=="mlaunch")
	{
		launch=true;
		mrun();
		launch=false;
	}
/// Добавить в kLaunch
	if(func=="addklaunch")
	{
		addTokLaunch(curItem);
	}
/// Новая папка
	if(func=="newDir")
	{
		QString tmp="";
		if(showDlg->Show(lng_create_dir, lng_write_dir_name, "New Folder"))
		{
			tmp=showDlg->getText();
			createFolder(tmp);
		}
	}
/// Переименовать
	if(func=="renameDir" || func=="renameApp")
	{
		QString tmp="";
		if(showDlg->Show(lng_renaming, lng_rename_question.arg(data[curItem].Name), data[curItem].Name))
		{
			tmp=showDlg->getText();
			renameApp(curItem, tmp);
		}
	}
/// Удалить
	if(func=="delApp")
	{
		if(showDlg->Show(lng_removing, lng_remove_question.arg(data[curItem].Name), 2))
		{
			removeApp(curItem, 1);
		}
	}
	if(func=="delDir")
	{
		if(showDlg->Show(lng_removing, lng_remove_dir_question.arg(data[curItem].Name), 2))
		{
			removeApp(curItem, 0);
		}
	}
/// Переместить приложение
	if(func=="moveApp")
	{
		//moveApp(curItem);
		showDlg->Show(lng_error, "This function don't support at this version", 2);
	}
/// Переместить в папку
	if(func=="moveToDir")
	{
		m2d=data[curItem];
		m2d_path=curId;
		changeSoftKeys(lng_Move, lng_Cancel);
		MoveToDir=true;
	}
/// Сортировка
	if(func=="reSort")
	{
		resortId="";
		ZConfig cfg(UserMenuTree, true);
		resort_line_b=resort_line=cfg.readEntry(curId, "Items", "");
		cfg.flush();
		changeSoftKeys(lng_Take, lng_Finish);
		Resort=true;
	}
///	Проверка обновления
	if(func=="chkUpdate")
	{
		GprsChk();
	}
}

void kIconGrid::createFolder(QString name)
{
	if(name!="" && name.left(1)!=" ")
	{
		QString uid;
		system("uuidgen > /tmp/folderuid");
		QFile file("/tmp/folderuid");
		if( file.open(IO_ReadOnly) )		
		{
			QTextStream stream( &file );
			//stream.setEncoding ( QTextStream::UnicodeUTF8 );
			uid=stream.readLine();
		}
		if(uid!="" && uid.left(1)!=" ")
		{
			data_struct dat;
			dat.Name=name;
			dat.Id = uid;
			dat.Type = 1;
			dat.Place = 1;
			dat.icon="mm_folder01_std.g";
			ZConfig cfg(USER_REG, true);
			cfg.writeEntry(uid, "AniIcon", "mm_folder01_ani.g");
			cfg.writeEntry(uid, "Attribute", "8");
			cfg.writeEntry(uid, "BigIcon", dat.icon);
			cfg.writeEntry(uid, "FixedAllPosition", "0");
			cfg.writeEntry(uid, "FixedPosition", "0");
			cfg.writeEntry(uid, "Icon", dat.icon);
			cfg.writeEntry(uid, "Name", dat.Name);
			cfg.writeEntry(uid, "Type", dat.Type);
			if(cfg.groupExists(uid))
			{
				ZConfig kfg(UserMenuTree, true);
				name=kfg.readEntry(curId, "Items", "");
				name+=";"+uid;
				kfg.writeEntry(curId, "Items", name);
				kfg.flush();

				userdb->add(dat);
				userdb->search(dat, uid);
				data.push_back(dat);
				
				it_c++;
				h=it_c/w;
				if(it_c%w!=0)
					h++;
				
				paint(0);
			}
			else
				showDlg->Show(lng_error, lng_cant_create_dir, 0);
			cfg.flush();
		}
		else
			showDlg->Show(lng_error, lng_cant_create_dir, 0);
	}
	else
		showDlg->Show(lng_error, lng_wrong_name, 0);
}

void kIconGrid::removeApp(int index , bool app)
{
	showDlg->Show(lng_removing, "Please wait..", 3);
	QString place;
	if(data[index].Place==1)
		place=USER_REG;
	if(data[index].Place==2)
		place=PHONE_REG;
	if(data[index].Place==3)
		place=MMC_REG;
	
	ZConfig cfg(place, true);
	if(cfg.groupExists(data[index].Id))
	{
		cfg.clearGroup(data[index].Id);
		if(cfg.groupExists(data[index].Id))
			showDlg->Show(lng_error, lng_del_error.arg(data[index].Name), 0);
		else
		{
			if(app)
				system(QString("rm -rf %1 ").arg(data[index].Path));
			if(data[index].Place==1)
			{
				userdb->remove(data[index].Id);
			}
			if(data[index].Place==2)
				phonedb->remove(data[index].Id);
			if(data[index].Place==3)
				carddb->remove(data[index].Id);
			
			if(app)
			{
				QByteArray dat;
				QDataStream stream(dat, IO_ReadOnly);
				stream << data[index].Id << curId;
				QCopChannel::send("AM/RegistryiMgr/Channel", "notifyUpdateHomeView");
				QCopChannel::send("AM/RegistryiMgr/Channel", "UninstallApp(QString)", dat);
			}
			
			removeElement(index);
		}
		cfg.flush();
		paint(0);
		showDlg->Show(lng_removing, "Ok", 1);
	}
	else
		showDlg->Show(lng_error, lng_cant_find.arg(data[index].Name), 0);
}

void kIconGrid::renameApp(int index, QString name)
{
	showDlg->Show(lng_renaming, "Please wait..", 3);
	if(name!="" && name.left(1)!=" ")
	{
		QString place;			
		if(data[index].Place==1)
			place=USER_REG;
		if(data[index].Place==2)
			place=PHONE_REG;
		if(data[index].Place==3)
			place=MMC_REG;
		ZConfig cfg(place, true);
		if(cfg.groupExists(data[index].Id))
			cfg.writeEntry(data[index].Id, "Name", name);
		if(name==cfg.readEntry(data[index].Id, "Name", ""))
		{
			data[index].Name=name;
			if(data[index].Place==1)
				userdb->rename(data[index].Id, name);
			if(data[index].Place==2)
				phonedb->rename(data[index].Id, name);
			if(data[index].Place==3)
				carddb->rename(data[index].Id, name);
			paint(0);
			showDlg->Show(lng_renaming, "Ok", 1);
		}
		else
			showDlg->Show(lng_error, lng_cant_rename.arg(data[index].Name), 0);
		cfg.flush();
	}
	else
		showDlg->Show(lng_error, lng_wrong_name, 0);
}

void kIconGrid::addTokLaunch(int index)
{
	if(data[index].Type!=1)
	{
		ZConfig cfg("/ezx_user/download/appwrite/am/AmConfig", true);
		QString tmp=cfg.readEntry("ILaunch", "Items", "");
		tmp+=";"+data[index].Id;
		cfg.writeEntry("ILaunch", "Items", tmp);
		tmp=cfg.readEntry("ILaunch", "Items", "");
		if(tmp.find(data[index].Id)!=-1)
		{
			if (QCopChannel::isRegistered("kLaunch"))
			QCopChannel::send("kLaunch", "update");
		}
		else
			showDlg->Show(lng_error, lng_add_error.arg(data[index].Name), 0);
		cfg.flush();
	}
	else
		showDlg->Show(lng_error, lng_add_error.arg(data[index].Name), 0);
}

void kIconGrid::moveApp(int index)
{
	if(data[index].Type!=1)
	{
		int place=data[index].Place-2;
		if(place>=0)
		{
			if(showDlg->Show(lng_moving, lng_move_app_question[place].arg(data[curItem].Name), 2))
			{
				QString reg_place, qtdl_path;
				if(place)
				{
					reg_place=PHONE_REG;
					qtdl_path="/ezxlocal/.system/QTDownLoad/";
				}
				else
				{
					reg_place=MMC_REG;
					qtdl_path="/mmc/mmca1/.system/QTDownLoad/";
				}
				
				ZConfig cfg(reg_place, true);
				cfg.writeEntry(data[index].Id, "AniIcon", "");
				cfg.writeEntry(data[index].Id, "AppID", QString("{%1}").arg(data[index].AppId));
				cfg.writeEntry(data[index].Id, "Args", "");
				cfg.writeEntry(data[index].Id, "Attribute", "4");
				cfg.writeEntry(data[index].Id, "BigIcon", data[index].icon);
				cfg.writeEntry(data[index].Id, "Daemon", "0");
				cfg.writeEntry(data[index].Id, "Directory", data[index].Path);
				cfg.writeEntry(data[index].Id, "Eraseable", "1");
				cfg.writeEntry(data[index].Id, "Exec", data[index].Exec);
				cfg.writeEntry(data[index].Id, "FixedAllPosition", "0");
				cfg.writeEntry(data[index].Id, "FixedPosition", "0");
				cfg.writeEntry(data[index].Id, "GroupID", "root");
				cfg.writeEntry(data[index].Id, "Icon", data[index].icon);
				cfg.writeEntry(data[index].Id, "InstalledDate", "");
				cfg.writeEntry(data[index].Id, "JavaId", "-1");
				cfg.writeEntry(data[index].Id, "MassStorageStatus", "0");
				cfg.writeEntry(data[index].Id, "MpkgFile", "");
				cfg.writeEntry(data[index].Id, "Name", data[index].Name);
				cfg.writeEntry(data[index].Id, "OsVersion", "");
				cfg.writeEntry(data[index].Id, "Shared", "");
				cfg.writeEntry(data[index].Id, "Size", "!Size");
				cfg.writeEntry(data[index].Id, "Type", "2");
				cfg.writeEntry(data[index].Id, "UserID", "root");
				cfg.writeEntry(data[index].Id, "Visible", "1");
				cfg.flush();
				
				system(QString("mv %1 %2").arg(data[index].Path).arg(qtdl_path+kGetPath(data[index].Path)));
				//if()
					removeApp(index , 1);
				//else
				//	showDlg->Show(lng_moving, lng_error, 0);
			}
		}
		else
			showDlg->Show(lng_moving, lng_error, 0);
	}
	else
		showDlg->Show(lng_moving, lng_error, 0);
}

void kIconGrid::Move2Dir()
{
	//showDlg->Show(lng_moving, UTF("переместили"), 1);
	QString tmp_line;
	ZConfig cfg(UserMenuTree, true);
	tmp_line=cfg.readEntry(m2d_path, "Items", "");
	tmp_line.remove(tmp_line.find(m2d.Id),QString(m2d.Id+";").length());
	cfg.writeEntry(m2d_path, "Items", tmp_line);
	tmp_line=cfg.readEntry(curId, "Items", "");
	tmp_line+=";"+m2d.Id;
	cfg.writeEntry(curId, "Items", tmp_line);
	cfg.flush();
	
	data.push_back(m2d);
	it_c++;
	h=it_c/w;
	if(it_c%w!=0)
		h++;
	//QCopChannel::send("AM/RegistryiMgr/Channel", "notifyUpdateHomeView");
}

void kIconGrid::ChangePos()
{
	if(resortId=="")
	{
		resortId=data[curItem].Id;
		changeSoftKeys(data[curItem].Name, lng_Finish);
	}
	else
	{
		if(resortId!=data[curItem].Id)
		{
			int tmp_i=cur_i;int tmp_j=cur_j;int tmp_hv=h_vis_s;
			/*int pos1=resort_line.find(resortId);
			resort_line.remove(pos1,QString(resortId+";").length());
			int pos=resort_line.find(data[curItem].Id);
			if(pos>=pos1)
			{
				pos+=resortId.length();
				resortId=";"+resortId;
			}
			else
				resortId+=";";
			resort_line=resort_line.left(pos)+resortId+resort_line.right(resort_line.length()-pos);*/
			
			/**int pos=resort_line.find(resortId);
			int pos1=resort_line.find(data[curItem].Id);
			if(pos>pos1)
			{
				resort_line.remove(pos, resortId.length());
				resort_line=resort_line.left(pos1)+resortId+resort_line.right(resort_line.length()-pos1);
				resort_line.remove(resort_line.find(data[curItem].Id), data[curItem].Id.length());
				resort_line=resort_line.left(pos)+data[curItem].Id+resort_line.right(resort_line.length()-pos);
			}
			else
			{
				resort_line.remove(pos1, data[curItem].Id.length());
				resort_line=resort_line.left(pos)+data[curItem].Id+resort_line.right(resort_line.length()-pos);
				resort_line.remove(resort_line.find(resortId), resortId.length());
				resort_line=resort_line.left(pos1)+resortId+resort_line.right(resort_line.length()-pos1);
			}*/
			
			QStringList tmp_items;
			int pos=0;
			resort_line+=";";
			while(resort_line.find(";")>-1)
			{
				pos = resort_line.find(";");
				tmp_items.append(resort_line.left(pos));
				resort_line.remove(0, pos+1);
			}
			
			resort_line="";
			for(int i=0;i<(int)tmp_items.count();i++)
			{
				if(tmp_items[i]!=resortId && tmp_items[i]!=data[curItem].Id)
					resort_line+=tmp_items[i]+";";
				else
				{
					if(tmp_items[i]==resortId)
						resort_line+=data[curItem].Id+";";
					else
						resort_line+=resortId+";";
				}
			}
			
			ZConfig cfg(UserMenuTree, true);
			cfg.writeEntry(curId, "Items", resort_line);
			cfg.flush();
			readItemsCfg(UserMenuTree, curId);
			cur_i=tmp_i;cur_j=tmp_j;h_vis_s=tmp_hv;
			curItem=cur_i+w*cur_j;
			paint(0);
		}
		resortId="";
		changeSoftKeys(lng_Take, lng_Finish);
	}
}

void kIconGrid::GprsChk()
{
	if(showDlg->Show(UTF("Обновление"), UTF("Подключиться через GPRS?"), 2))
	{
		QString profName;
		getProfileNamebySelect(profName); 
		linkId=ses->openLink(profName);
		if(linkId<0)
			showDlg->Show("GPRS", UTF("Не удалось установить соединение GPRS"), 0);
		else
			showDlg->Show("GPRS", UTF("Попытка соединения\nПожалуйста подождите.."), 3);
	}
	else
		Update();
}

void kIconGrid::Update()
{
	QString SERVER="http://e2.at.ua/rep/upd/kMMenu";
	QString CUR_VER="b157";
	
	showDlg->Show(UTF("Обновление"), UTF("Проверка новой версии\nПожалуйста подождите.."), 3);
	QDir dir;
	dir.setPath(path);
	dir.mkdir("upd", false);
	dir.setPath(path+"upd");
	dir.mkdir("kMMenu", false);
	system(wget.arg(path+"upd/new.ver").arg(SERVER+"/new.ver"));
	
	QFile f(path+"upd/new.ver");
	if(f.exists())
	{
		ZConfig cfg(path+"upd/new.ver", true);
		QString ver=cfg.readEntry("Update", "Ver", CUR_VER);
		if(CUR_VER==ver)
			showDlg->Show(UTF("Обновление"), UTF("У Вас установлена последняя версия"), 1);
		else
		{
			QString line=cfg.readEntry("Update", lang_name, cfg.readEntry("Update", "en", "Empty description"));
			line+="\n__________\nSize: "+cfg.readEntry("Update", "Size", "Unknown")+UTF("\nЗагрузить обновление?");
			if(showDlg->Show(UTF("Обновление до "+ver), line, 2))
			{
				showDlg->Show(UTF("Обновление"), UTF("Загрузка пакета обновления\nПожалуйста подождите.."), 3);
				system(wget.arg(path+"upd/update.tgz").arg(SERVER+"/update.tgz"));
				QFile f(path+"upd/update.tgz");
				if(f.exists())
				{
					showDlg->Show(UTF("Обновление"), UTF("Установка пакета обновления\nПожалуйста подождите.."), 3);
					system("busybox tar -xfz "+path+"upd/update.tgz -C "+path+"upd/kMMenu");
					system("cp -f -R "+path+"upd/kMMenu "+path);
					system("chmod 777 -R "+path);
					showDlg->Show(UTF("Обновление"), UTF("Пакет обновления успешно загружен и установлен"), 1);
				}
				else
					showDlg->Show(UTF("Обновление"), UTF("Не удалось загрузить пакет обновления"), 0);
			}
		}
		cfg.flush();
	}
	else
		showDlg->Show(UTF("Обновление"), UTF("Не удалось загрузить информацию о новой версии"), 0);
	system("rm -f -R "+path+"upd &");
	ses->closeLink(linkId);
}

void kIconGrid::connected()
{
	//showDlg->Show("GPRS", UTF("Соединение GPRS установлено"), 1);
	Update();
}

void kIconGrid::connect_f()
{
	showDlg->Show("GPRS", UTF("Не удалось установить соединение GPRS"), 0);
}

void kIconGrid::removeElement(int index)
{
	std::vector<data_struct> tmp;
	tmp=data;
	data.clear();
	for(int i=0; i<it_c; i++)
	{
		if(index!=i)
			data.push_back(tmp[i]);
	}
	it_c--;
	h=it_c/w;
	if(it_c%w!=0)
		h++;
}

QString kIconGrid::activeItem()
{
	return data[curItem].Name;
}

QString kIconGrid::activePath()
{
	QString res="";
	
	//if(curId==MainMenuId)
	for(int i=0;i<(int)lnga_id.count();i++)
	{
		if(lnga_id[i]==curId)
		{
			res=lnga_name[i];
			return res;
			break;
		}
	}
	if(res=="")
	{
		data_struct tmp;
		if(userdb->search(tmp, curId) || phonedb->search(tmp, curId) || carddb->search(tmp, curId) || sysdb->search(tmp, curId))
			res=tmp.Name;
		else
			res="Unknown";
	}
	
	return res;
}
