/**********************************************************
kMMenu for E2 v0.1b

Written  by Strelok Vlad Kolerts
5/12/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
***********************************************************/

#include <QWidget.h>
#include <qcopchannel_qws.h>

/*#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <getopt.h>
#include <dirent.h>
#include <sys/stat.h>*/

#include <ZConfig.h>
#include <SETUP_API.h>
#include <ZDataSessionManager.h>

#include <qtimer.h>
#include <qdir.h>

#include "kOptionsMenu.h"
#include "kShowDlg.h"
#include "Registry.h"

extern QMovie* gif;

//extern "C" void UTIL_SetSideKeyLock(int);

class kIconGrid : public QWidget
{
    Q_OBJECT

public:
    kIconGrid(QString cfg_name);
    //~kIconGrid();
	
	QPainter	p;
	QPixmap* 	bg_buf;
	QPixmap 	bg_tmp;
	QPixmap 	w_bg, p_bg;
	QPixmap		cursor;
	QPixmap hsIcon;
	
	kOptionsMenu* 	options;
	kShowDlg*		showDlg;
	
	SETUP_API* api;
	
	ZDataSessionManager*	ses;
	int linkId;
	
	QColor		nameCol, nameCol_act, sbsCol, sbCol;
	int			nameSize, nameSize_act;
	
	QFont	font;
	QFont	font_act;
	QTimer*	timer;

	bool inFocus;
	bool delay_out, transparency_bg;
	int animation, anim_delay, anim_key_delay;
	int animation_t, anim_delay_t, anim_key_delay_t;
	int anim_act_jump, anim_act_jump_c, anim_act_jump_t;
	bool anim_act_gif, anim_act_gif_upd;
	bool anim_enable;
	bool vibro_type;
	int vibr_duration, vibr_level;
	int vibr_launch_duration, vibr_launch_level;
	int it_c;
	int vpading, hpading, p_sb, p_sb2;
	int icon_p, bicon_p;
	int scroll_w, sb_w;
	int x, y, width, height;
	int w, h, h_vis, h_vis_s, h_vis_change;
	
	int scrollsize;
	
	int cur_i, cur_j, curItem;
	QString	curId;
	
	int but_size, icon_size, bicon_size, center, bcenter;
	bool quit;
	
	std::vector<data_struct> data;
	
	bool Resort, MoveToDir;
	data_struct m2d;
	QString m2d_path;
	QString resort_line_b, resort_line, resortId;
	
	QString		Wallpaper;

	void paint(int anim);
	void set_paints();
	bool left, right, up, down, launch;
	
	void run(QString id);
	void mrun();
	
	int run_c;
	bool launch_run;
	
///FUNC
	void animEnable();
	
	void showOptions();
	
	void delay(int msec);
	
	void updateReg();
	void removeElement(int index);
	
	void createFolder(QString name);
	void removeApp(int index, bool app);
	void renameApp(int index, QString name);
	void addTokLaunch(int index);
	void moveApp(int index);
	void Move2Dir();
	void ChangePos();
	void GprsChk();
	void Update();

	QString cfgname;
	void readSkinCfg();
	void readItemsCfg(QString file, QString ID);
	void readMainMenu();
	
	QString activeItem();
	QString activePath();
	
	void changeSoftKeys(QString left_soft, QString right_soft);
	
	void sendHardKey(int key);
	//QString kGetPath ( const char*ChineseString );
	//void readCfgItem(QString id, QString place, QString item_path);
	
	void keyPressEvent(QKeyEvent *event);
	void keyReleaseEvent(QKeyEvent *event);
	void focusOutEvent(QFocusEvent* event);
	void focusInEvent(QFocusEvent* event);
	
public slots:
	void repaint();
	void showMenu();
	void hideMenu();
	void refreshBg();
	void gifUpdated();
	void keyBoardProcess();
	//void slotQCopReceived(const QCString &msg);
	void slotOptionsSelected(QString);
	
	void connected();
	void connect_f();

signals:
	void changeSoftKeysName(QString left_soft, QString right_soft);
	void changeFocus(bool focus);
	void fullHide();
	void updateActiveItem();
	void updateActivePath();
};
